#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
  #include <avr/io.h>
  #include <util/delay.h>
#endif

#define PIN 4

// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
//   NEO_RGBW    Pixels are wired for RGBW bitstream (NeoPixel RGBW products)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(22 , PIN, NEO_GRB + NEO_KHZ800);

// IMPORTANT: To reduce NeoPixel burnout risk, add 1000 uF capacitor across
// pixel power leads, add 300 - 500 Ohm resistor on first pixel's data input
// and minimize distance between Arduino and first pixel.  Avoid connecting
// on a live circuit...if you must, connect GND first.

void setup() {
  // This is for Trinket 5V 16MHz, you can remove these three lines if you are not using a Trinket
  #if defined (__AVR_ATtiny85__)
    if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
  #endif
  // End of trinket special code
// set PB0 to be output
DDRB |= (1 << PB0);      //replaces pinMode(PB0, OUTPUT);
//DDRB |= (1 << PB3);       //replaces pinMode(PB3, OUTPUT);
PORTB |= (1 << PB0);      //replaces digitalWrite(PB0, HIGH);
//   PORTB &= ~(1 << PB3);    //replaces digitalWrite(PB3, LOW);
//   PORTB &= ~(1 << PB0);    //replaces digitalWrite(PB0, LOW);
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
}

void loop() {
  uint16_t Brightness = 20;
  uint16_t Dim = 100/Brightness; // Percentage brightness
  checkBatteryVoltage(1,Dim);
  delay(2000);
  colorWipe(strip.Color(255/Dim, 0, 0), 50); // Red
  colorWipe(strip.Color(0, 255/Dim, 0), 50); // Green
  randomSolid(15,Dim);
 fadeUpRandom(50,Dim);
  randomSolid(15,Dim);
  
  randomColor(100,Dim);
  randomSolid(15,Dim);
  xmasColor(100,Dim);
  randomSolid(15,Dim);
  colorWipe(strip.Color(255/Dim, 0, 0), 10); // Red
  colorWipe(strip.Color(0, 255/Dim, 0), 10); // Green
  randomColor(10,Dim);
  xmasColor(10,Dim);
  randomSolid(15,Dim);
  
  
  
  
  //for(uint16_t i=0; i<20; i++) {
  //colorWipe(strip.Color(255, 255, 255), 1);
  //delay(5000);
  //colorWipe(strip.Color(0, 0, 0), 1);
  //}
  //rainbow(20,Dim);
  //rainbowCycle(20);
  //theaterChaseRainbow(50);
}

// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}
void checkBatteryVoltage(uint8_t wait,uint16_t Dim) {
    for(uint16_t j=0; j<strip.numPixels(); j++) {
    strip.setPixelColor(j, 0, 0, 0);
    strip.show();
    }
    int analogInPin = A3;
    pinMode(analogInPin, INPUT);
    int analogIn = analogRead(analogInPin); // Read analog voltage
    //860 = 4.2V Fully charged 614 = 3V Low volt cut-off
    analogIn = analogIn - 614;
    int Voltage =  strip.numPixels()*analogIn/246;
    if (analogIn <10) {PORTB &= ~(1 << PB0);}
    for(uint16_t i=0; i<Voltage; i++) {
    strip.setPixelColor(i, 0, 0, 255/Dim);
    strip.show();
    delay(wait);
  }

}
void xmasColor(uint8_t wait,uint16_t Dim) {
  uint16_t i;
  for(i=0; i<100; i++) {
  strip.setPixelColor(random(strip.numPixels()),255/Dim,0,0);
  strip.setPixelColor(random(strip.numPixels()),0,255/Dim,0);    
  strip.setPixelColor(random(strip.numPixels()),random(255/Dim),random(255/Dim),random(255/Dim));
      strip.show();
    delay(wait);
    }
}
void fadeUpRandom(uint8_t wait,uint16_t Dim) {
  uint16_t i,j;
  uint16_t r =random(255/Dim);
  uint16_t g =random(255/Dim);
  uint16_t b =random(255/Dim);
  
  //uint32_t colorToReach = (random(255/Dim),random(255/Dim),random(255/Dim));
  for(i=10; i>1; i--) {
    for (j=0; j<strip.numPixels(); j++){
      strip.setPixelColor(j,r/i,g/i,b/i);
        }
    strip.show();
    delay(wait);
    }
}


void randomSolid(uint8_t wait,uint16_t Dim) {
  uint16_t i,j;
  uint16_t r =random(255/Dim);
  uint16_t g =random(255/Dim);
  uint16_t b =random(255/Dim);
  
  //uint32_t colorToReach = (random(255/Dim),random(255/Dim),random(255/Dim));
  for(i=0; i<100; i++) {
    for (j=0; j<strip.numPixels(); j++){
      strip.setPixelColor(j,r,g,b);
        }
    strip.show();
    delay(wait);
    }
}
void randomColor(uint8_t wait,uint16_t Dim) {
  uint16_t i;
  for(i=0; i<100; i++) {
  strip.setPixelColor(random(strip.numPixels()),random(255/Dim),random(255/Dim),random(255/Dim));
      strip.show();
    delay(wait);
    }
}
void rainbow(uint8_t wait,uint16_t Dim) {
  uint16_t i, j;

  for(j=0; j<255; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}
